# Change commit and date if new from upstream
%global commit ef2dd2aedf8f6ddd373e922daea1b545b383c403
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global date 20250616

Name:     nivlheim
Version:  2.7.35
Release:  3.%{date}git%{shortcommit}%{?dist}
Summary:  File collector for UiO

Group:    Applications/System
License:  GPLv3+

URL:      https://github.com/unioslo/nivlheim
Source0:  %{name}-%{shortcommit}.tar.gz

BuildArch: noarch

%global _binary_filedigest_algorithm 1
%global _source_filedigest_algorithm 1

%description
This package is the base package for Nivlheim, the file collector for
UiO.

%package client
Summary:  Client component of the file collector for UiO
Group:    Applications/System

Requires: %{name} = %{version}-%{release}
Requires: perl, openssl, dmidecode
Requires: perl(IO::Socket::INET6)
Requires: perl(IO::Socket::SSL)
Requires: perl(IO::File)
Requires: perl(Socket)
Requires: perl(Net::DNS)
Requires: perl(Archive::Tar)
Requires: perl(HTTP::Request::Common)
Requires: perl(Sys::Hostname)
Requires: perl(Sys::Syslog)
Requires: perl(File::Path)
Requires: perl(File::Basename)
Requires: perl(Getopt::Long)
Requires: perl(YAML::XS)
%{?systemd_requires}

BuildRequires: systemd
BuildRequires: perl(IO::Socket::INET6)
BuildRequires: perl(IO::Socket::SSL)
BuildRequires: perl(IO::File)
BuildRequires: perl(Socket)
BuildRequires: perl(Net::DNS)
BuildRequires: perl(Archive::Tar)
BuildRequires: perl(HTTP::Request::Common)
BuildRequires: perl(Sys::Hostname)
BuildRequires: perl(Sys::Syslog)
BuildRequires: perl(File::Path)
BuildRequires: perl(File::Basename)
BuildRequires: perl(Getopt::Long)
BuildRequires: perl(YAML::XS)

%description client
This package contains the client component of Nivlheim, the file
collector for UiO.

%prep
%setup -q -n unioslo-%{name}-%{shortcommit}

%build

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sysconfdir}/nivlheim
mkdir -p %{buildroot}%{_localstatedir}/nivlheim
install -p -m 0744 client/nivlheim_client %{buildroot}%{_bindir}/
install -p -m 0644 client/client.conf %{buildroot}%{_sysconfdir}/nivlheim
%if (0%{?rhel} == 7)
install -p -m 0644 -D client/nivlheim_client-rhel7.service %{buildroot}%{_unitdir}/nivlheim_client.service
%else
install -p -m 0644 -D client/nivlheim_client.service %{buildroot}%{_unitdir}/nivlheim_client.service
%endif
install -p -m 0644 -D client/nivlheim_client.timer %{buildroot}%{_unitdir}/nivlheim_client.timer

%check
perl -c %{buildroot}%{_bindir}/nivlheim_client

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root, -)
%dir %{_localstatedir}/nivlheim
%dir %{_sysconfdir}/nivlheim

%files client
%defattr(-, root, root, -)
%{_bindir}/nivlheim_client
%ghost /usr/sbin/nivlheim_client
%config(noreplace) %{_sysconfdir}/nivlheim/client.conf
%{_unitdir}/nivlheim_client.service
%{_unitdir}/nivlheim_client.timer

%pre client
if [ $1 -gt 1 ]; then
    # This is an upgrade (install count > 1)
    if [ -f /usr/sbin/nivlheim_client ]; then
        rm -f /usr/sbin/nivlheim_client
    fi
fi

%systemd_post nivlheim_client.timer
systemctl enable --now nivlheim_client.timer

%preun client
%systemd_preun nivlheim_client.timer

%changelog
* Mon Jun 23 2025 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 2.7.35-3
- Change installation path to /usr/bin
- Add pre-install hook that deletes /usr/sbin/nivlheim_client (%ghost didn't work)

* Wed Apr 23 2025 Trond Hasle Amundsen <trondham@uio.no> - 2.7.15-2
- Fix nivlheim_client path for f42

* Thu Oct 20 2022 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 2.7.15-1
- Upstream changes
- Added dependency on the package perl-YAML-LibYAML
- Removed build step that patched the version number, no longer needed

* Wed Jun  8 2022 Trond Hasle Amundsen <trondham@uio.no> - 2.7.4-4
- Release bump for el9

* Fri May 20 2022 Trond Hasle Amundsen <trondham@uio.no> - 2.7.4-3
- Move Requires and BuildRequires to client subpkg
- Fix post and preun scripts

* Mon Nov 29 2021 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 2.7.4-1
- Upstream changes

* Thu Apr 16 2020 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 2.7.3-2
- Upstream changes

* Mon Mar 09 2020 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 2.7.3-1
- Upstream changes

* Thu Nov 21 2019 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 2.5.2-1
- Upstream changes

* Tue Jun 11 2019 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 2.2.0-1
- Upstream changes

* Wed May 02 2018 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 1.9.2-2
- Upstream bugfix

* Thu Apr 26 2018 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 1.9.2-1
- Upstream changes: New source repository, re-written code

* Wed Jul 19 2017 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 1.9.0-1
- Upstream changes: Bugfix: Needed better HTTP protocol compliance

* Thu Mar 23 2017 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 1.06-1
- Upstream changes: Added support for cmd alias and prefer UiO network in client

* Tue Mar 14 2017 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 1.05-1
- Upstream changes: Can renew cert even outside trusted ip ranges

* Mon Nov 28 2016 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 1.04-2
- Modified the spec file because source was moved to Bitbucket

* Thu May 19 2016 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 1.04-1
- Upstream changes: Fixed permissions on /var/run/nivlheim_client_last_run
- Upstream changes: New option to specify which local ip address to bind to

* Thu Nov 26 2015 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 1.03-1
- Upstream changes: Fix in nivlheim_client for OSX uses ifconfig instead of ip

* Thu Sep  3 2015 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 1.02-1
- Upstream changes: Fix in nivlheim_client for environments with esoteric DNS setups

* Fri Aug 28 2015 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 1.01-1
- Upstream changes: Bugfix in nivlheim_client for machines with only IPv6.

* Fri Jun 26 2015 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 1.0-1
- Upstream changes: Support machines with multiple ip addresses,
  longer command lines, and easier monitoring.

* Mon Mar  9 2015 Trond Hasle Amundsen <t.h.amundsen@usit.uio.no> - 0.42-2.20150113gitd11fd36
- Various spec fixes for el5

* Tue Jan 13 2015 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 0.42-1
- Upstream changes to make the package Debian-compatible.

* Wed Sep 17 2014 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 0.41-1
- Upstream bugfixes, and client no longer needs Socket::GetAddrInfo.

* Thu Aug 28 2014 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 0.4-1
- Client supports RHEL5, new cmdline params, minor improvements

* Wed Aug 06 2014 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 0.3-1
- Minor upstream and package improvements

* Mon Jun 30 2014 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 0.2-1
- Upstream bugfixes

* Wed Jun 25 2014 Øyvind Hagberg <oyvind.hagberg@usit.uio.no> - 0.1-1
- Bugfix: Patch0 (:newapi in /usr/sbin/nivlheim_client) must be applied for RHEL7 too
- Bugfix: The directory /var/nivlheim should be created during installation
- Upstream changes

* Thu Jun 19 2014 Øyvind Hagberg <oyvind.hagberg@usit.uio.no>
- Upstream changes
- Removed the CA file from the client package, it's no longer used

* Mon Jun 02 2014 Øyvind Hagberg <oyvind.hagberg@usit.uio.no>
- Upstream changes

* Thu May 22 2014 Øyvind Hagberg <oyvind.hagberg@usit.uio.no>
- Upstream changes
- Marked configuration files in the .spec file

* Fri May 16 2014 Øyvind Hagberg <oyvind.hagberg@usit.uio.no>
- First package build
